Subject: Re: bug#74142: [rust-team] rust-bootstrap fails parallel build on x86-64

From: Maxim Cournoyer <[email-masked]>
Date: Sat, 07 Dec 2024 22:45:32 +0900

Hi,

Greg Hogan <[email-masked]> writes:

> On Sun, Nov 3, 2024 at 2:49 AM Efraim Flashner <[email-masked]> wrote:
>>
>> On Thu, Oct 31, 2024 at 03:13:40PM -0400, Greg Hogan wrote:
>> > derivation: 83qbfg0xxsfr5lsc81m5a770c7c7b55k-rust-1.54.0.drv
>> > commit: 6e50b0c56a8cc767bd3acb26638f78c450bde718
>> >
>> > Build log attached, tail portion below. Has consistently failed to
>> > build unless cores=1.
>> >
>> > The package definition has "#:parallel-build? ,(target-x86-64?)" but
>> > the noted build issue ("race conditions between various dependent
>> > crates") is also seen on x86-64.
>> >
>> > It is only the 1.54 build with mrustc that fails in this manner, the
>> > following rust packages in the chain build fine with parallelism
>> > enabled.
>> >
>> > Greg
>>
>> I see the note there says something about ppc64le having a race
>> condition too. My machine has "only" 24 cores, so I didn't run into
>> anything, but I see you're building with 32 cores. IIRC the ppc64le
>> machine was building with at least 32 cores also.
>>
>> Can you try building rust-1.54 with only 24 cores and see if that works
>> for you? If it does then I think we can switch the (job-count) variable
>> to (min 24 (parallel-job-count))
>
> Log attached from what looks to be a similar failure on an 8 core instance.

I encountered the same problem on a 32 "cores" (aka threads) machine.
I've reported it here [0].

[0]  https://github.com/thepowersgang/mrustc/issues/343

-- 
Thanks,
Maxim